(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@angular/platform-browser'), require('@ngx-translate/core')) :
    typeof define === 'function' && define.amd ? define('kg-language-selector', ['exports', '@angular/core', '@angular/common/http', '@angular/platform-browser', '@ngx-translate/core'], factory) :
    (global = global || self, factory(global['kg-language-selector'] = {}, global.ng.core, global.ng.common.http, global.ng.platformBrowser, global.core$1));
}(this, (function (exports, core, http, platformBrowser, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // import { AuthenticationService } from "@digitalmedarbeider/authentication";
    // import { HttpHeaderOptions } from "src/app/dtos/http-header-option";
    // import { LoaderService } from "../loader.service";
    var KGApiService = /** @class */ (function () {
        // httpOptions: HttpHeaderOptions = new HttpHeaderOptions();
        function KGApiService(http) {
            // this.httpOptions.headers = new HttpHeaders({
            //   "Content-Type": "application/json,image/jpg,image/png",
            //   "Access-Control-Allow-Origin": "*",
            //   "Access-Control-Allow-Credentials": "true",
            //   Authorization: "Bearer " + this.authService.getToken(),
            // });
            this.http = http;
        }
        KGApiService.prototype.createAuthorizationHeader = function (headers) {
            return headers;
        };
        KGApiService.prototype.loadItems = function (path) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this.http
                    .get(path)
                    .subscribe(function (response) {
                    resolve(response);
                }, function (err) {
                    reject(err);
                }, function () {
                    // this.loaderService.hide();
                })
                    .add(function () { });
            });
        };
        KGApiService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        KGApiService = __decorate([
            core.Injectable()
        ], KGApiService);
        return KGApiService;
    }());

    var MyDemoLibService = /** @class */ (function () {
        function MyDemoLibService(kgapiservice) {
            this.kgapiservice = kgapiservice;
            this.translation_service_url = 'https://translation-api-dev.azurewebsites.net';
            this._languages_url = this.translation_service_url + "/Translation/code/kgmuadmin/language";
        }
        MyDemoLibService.prototype.getLanguages = function () {
            return this.kgapiservice.loadItems(this._languages_url);
        };
        MyDemoLibService.ctorParameters = function () { return [
            { type: KGApiService }
        ]; };
        MyDemoLibService.ɵprov = core.ɵɵdefineInjectable({ factory: function MyDemoLibService_Factory() { return new MyDemoLibService(core.ɵɵinject(KGApiService)); }, token: MyDemoLibService, providedIn: "root" });
        MyDemoLibService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], MyDemoLibService);
        return MyDemoLibService;
    }());

    var MyDemoLibComponent = /** @class */ (function () {
        function MyDemoLibComponent() {
        }
        MyDemoLibComponent.prototype.ngOnInit = function () {
        };
        MyDemoLibComponent = __decorate([
            core.Component({
                selector: 'lib-my-demo-lib',
                template: "\n    <p>\n      my-demo-lib works!\n    </p>\n  "
            })
        ], MyDemoLibComponent);
        return MyDemoLibComponent;
    }());

    var DatatableService = /** @class */ (function () {
        function DatatableService(translate) {
            this.translate = translate;
            var lang = JSON.parse(window.sessionStorage.getItem('lang'));
            if (lang) {
                this.translate.use(lang);
                this.url = "assets/i18n/dt_e.json";
            }
            else {
                this.translate.use('no');
                this.url = "assets/i18n/dt_n.json";
            }
        }
        DatatableService.prototype.getUrl = function () {
            return this.url;
        };
        DatatableService.prototype.setUrl = function (lang) {
            if (lang == 'en') {
                this.url = "assets/i18n/dt_e.json";
            }
            else {
                this.url = "assets/i18n/dt_n.json";
            }
        };
        DatatableService.ctorParameters = function () { return [
            { type: core$1.TranslateService }
        ]; };
        DatatableService.ɵprov = core.ɵɵdefineInjectable({ factory: function DatatableService_Factory() { return new DatatableService(core.ɵɵinject(core$1.TranslateService)); }, token: DatatableService, providedIn: "root" });
        DatatableService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], DatatableService);
        return DatatableService;
    }());

    var LanguageSelectorComponent = /** @class */ (function () {
        function LanguageSelectorComponent(dimeTranslate, translate, dtService) {
            this.dimeTranslate = dimeTranslate;
            this.translate = translate;
            this.dtService = dtService;
            this.languages = [];
            this.preferredLanguage = 'no';
        }
        LanguageSelectorComponent.prototype.ngOnInit = function () {
            this.loadLanguages();
        };
        LanguageSelectorComponent.prototype.loadLanguages = function () {
            var _this = this;
            this.dimeTranslate.getLanguages().then(function (response) {
                _this.languages = response.map(function (resp) { return _this.convertLanguageRespose(resp); });
                var lng = _this.languages.map(function (lang) { return lang.shortCode2; });
                if (lng) {
                    _this.translate.addLangs(lng);
                    _this.translate.setDefaultLang('no');
                    var lang = JSON.parse(window.sessionStorage.getItem('lang'));
                    if (lang) {
                        _this.translate.use(lang);
                    }
                    else {
                        _this.translate.use(_this.preferredLanguage);
                    }
                }
            });
        };
        LanguageSelectorComponent.prototype.changeLanguage = function (language) {
            window.sessionStorage.setItem('lang', JSON.stringify(language));
            this.translate.use(JSON.parse(window.sessionStorage.getItem('lang')));
            this.dtService.setUrl(JSON.parse(window.sessionStorage.getItem('lang')));
        };
        LanguageSelectorComponent.prototype.convertLanguageRespose = function (response) {
            var param = {
                shortCode2: response.shortCode2.toLowerCase(),
                nameLocal: response.nameLocal
            };
            return param;
        };
        LanguageSelectorComponent.ctorParameters = function () { return [
            { type: MyDemoLibService },
            { type: core$1.TranslateService },
            { type: DatatableService }
        ]; };
        LanguageSelectorComponent = __decorate([
            core.Component({
                selector: 'lib-language-selector',
                template: "\n\n\n<li _ngcontent-put-c1=\"\" class=\"nav-item dropdown\"><a _ngcontent-put-c1=\"\" aria-expanded=\"false\"\n    aria-haspopup=\"true\" class=\"nav-link dropdown-toggle\" data-toggle=\"dropdown\" href=\"#\" id=\"languageSelector\" style=\"margin-top:-10px\"\n    role=\"button\"> {{ \"SelectLanguage\" | translate }} </a>\n  <div _ngcontent-put-c1=\"\" aria-labelledby=\"languageSelector\" class=\"dropdown-menu bg-dark-blue mt-4 mb-3\"\n    style=\"border-radius:15px;border: 1px solid white;\">\n    <!---->\n    <ng-container *ngFor=\"let lang of languages;let i = index\">\n      <!----><a _ngcontent-put-c1=\"\" class=\"dropdown-item text-white btn\" (click)=\"changeLanguage(lang.shortCode2)\">\n        <img *ngIf=\"lang.shortCode2 == 'en'\" src=\"https://cdn.britannica.com/79/4479-050-6EF87027/flag-Stars-and-Stripes-May-1-1795.jpg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'no'\" src=\"https://www.norden.org/sites/default/files/styles/content_size_800/public/2021-03/Flag_of_Norway.png\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'ar'\" src=\"https://upload.wikimedia.org/wikipedia/commons/b/bb/Arabic-Language-Flag.svg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'ur'\" src=\"https://flagemoji.com/wp-content/uploads/2020/02/Flag_of_Pakistan.svg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'am'\" src=\"https://cdn.britannica.com/12/12-004-A40EEB6F/Flag-Ethiopia.jpg\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n        <img *ngIf=\"lang.shortCode2 == 'so'\" src=\"https://upload.wikimedia.org/wikipedia/commons/thumb/a/a0/Flag_of_Somalia.svg/1200px-Flag_of_Somalia.svg.png\" width=\"25\" height=\"25\" class=\"img img-circle\"> \n          {{\" \"}}{{ lang.nameLocal }}\n      </a>\n      <!---->\n      <div _ngcontent-put-c1=\"\" class=\"dropdown-divider\"></div>\n    </ng-container>\n\n\n  </div>\n</li>\n\n<!-- </ng-container> -->\n<!--  -->\n",
                styles: ["select{background-color:var(--background-primary)!important;border:1px solid #fff;color:var(--white-text-color);padding:3px 5px;border-radius:2px;text-transform:none;word-wrap:normal}.notification{display:none}.bg-dark-blue[_ngcontent-put-c1]{background-color:#707070}.language-select{background-color:var(--background-primary);border:1px solid #fff;color:var(--white-text-color);padding:3px 5px;border-radius:2px}.dropdown-item,.dropdown-toggle{cursor:pointer}.abc::-webkit-scrollbar{display:none;width:0;height:0}.groupHeader{color:var(--background-secondary);text-align:left}.dropdown-header{text-align:left}a:hover{color:#707070}.dropdown-menu a:hover{color:#707070!important}@media screen and (width:320px) and (height:568px){.dropdown-menu-lg{min-width:258px}}"]
            })
        ], LanguageSelectorComponent);
        return LanguageSelectorComponent;
    }());

    var MyDemoLibModule = /** @class */ (function () {
        function MyDemoLibModule() {
        }
        MyDemoLibModule = __decorate([
            core.NgModule({
                declarations: [MyDemoLibComponent, LanguageSelectorComponent],
                imports: [
                    core$1.TranslateModule.forRoot({}),
                    http.HttpClientModule,
                    platformBrowser.BrowserModule,
                ],
                exports: [MyDemoLibComponent, LanguageSelectorComponent],
                providers: [
                    KGApiService,
                ]
            })
        ], MyDemoLibModule);
        return MyDemoLibModule;
    }());

    exports.LanguageSelectorComponent = LanguageSelectorComponent;
    exports.MyDemoLibComponent = MyDemoLibComponent;
    exports.MyDemoLibModule = MyDemoLibModule;
    exports.MyDemoLibService = MyDemoLibService;
    exports.ɵa = KGApiService;
    exports.ɵb = DatatableService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=kg-language-selector.umd.js.map
