import { OnInit } from '@angular/core';
import { MyDemoLibService } from '../my-demo-lib.service';
import { TranslateService } from '@ngx-translate/core';
import { DatatableService } from '../services/datatable.service';
export declare class LanguageSelectorComponent implements OnInit {
    private dimeTranslate;
    translate: TranslateService;
    private dtService;
    languages: LangWithShortCode[];
    preferredLanguage: string;
    constructor(dimeTranslate: MyDemoLibService, translate: TranslateService, dtService: DatatableService);
    ngOnInit(): void;
    loadLanguages(): void;
    changeLanguage(language: any): void;
    convertLanguageRespose(response: any): LangWithShortCode;
}
export interface LangWithShortCode {
    nameLocal: string;
    shortCode2: string;
}
